diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/tcp-socket-state.cc ns-3.38/src/internet/model/tcp-socket-state.cc
--- ns-3.37/src/internet/model/tcp-socket-state.cc	2022-11-01 17:37:24.507395000 -0700
+++ ns-3.38/src/internet/model/tcp-socket-state.cc	2023-03-16 20:54:23.624868600 -0700
@@ -128,13 +128,21 @@
 {
 }
 
-const char* const TcpSocketState::TcpCongStateName[TcpSocketState::CA_LAST_STATE] = {"CA_OPEN",
-                                                                                     "CA_DISORDER",
-                                                                                     "CA_CWR",
-                                                                                     "CA_RECOVERY",
-                                                                                     "CA_LOSS"};
+const char* const TcpSocketState::TcpCongStateName[TcpSocketState::CA_LAST_STATE] = {
+    "CA_OPEN",
+    "CA_DISORDER",
+    "CA_CWR",
+    "CA_RECOVERY",
+    "CA_LOSS",
+};
 
-const char* const TcpSocketState::EcnStateName[TcpSocketState::ECN_CWR_SENT + 1] =
-    {"ECN_DISABLED", "ECN_IDLE", "ECN_CE_RCVD", "ECN_SENDING_ECE", "ECN_ECE_RCVD", "ECN_CWR_SENT"};
+const char* const TcpSocketState::EcnStateName[TcpSocketState::ECN_CWR_SENT + 1] = {
+    "ECN_DISABLED",
+    "ECN_IDLE",
+    "ECN_CE_RCVD",
+    "ECN_SENDING_ECE",
+    "ECN_ECE_RCVD",
+    "ECN_CWR_SENT",
+};
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/tcp-socket-state.h ns-3.38/src/internet/model/tcp-socket-state.h
--- ns-3.37/src/internet/model/tcp-socket-state.h	2022-11-01 17:37:24.507395000 -0700
+++ ns-3.38/src/internet/model/tcp-socket-state.h	2023-03-16 20:54:23.624868600 -0700
@@ -77,7 +77,7 @@
      * depending on the case.
      *
      */
-    typedef enum
+    enum TcpCongState_t
     {
         CA_OPEN,     //!< Normal state, no dubious events
         CA_DISORDER, //!< In all the respects it is "Open",
@@ -88,13 +88,13 @@
         CA_RECOVERY, //!< CWND was reduced, we are fast-retransmitting.
         CA_LOSS,     //!< CWND was reduced due to RTO timeout or SACK reneging.
         CA_LAST_STATE //!< Used only in debug messages
-    } TcpCongState_t;
+    };
 
     // Note: "not triggered" events are currently not triggered by the code.
     /**
      * \brief Congestion avoidance events
      */
-    typedef enum
+    enum TcpCAEvent_t
     {
         CA_EVENT_TX_START,        //!< first transmit when no packets in flight
         CA_EVENT_CWND_RESTART,    //!< congestion window restart. Not triggered
@@ -104,7 +104,7 @@
         CA_EVENT_ECN_IS_CE,       //!< received CE marked IP packet. Not triggered
         CA_EVENT_DELAYED_ACK,     //!< Delayed ack is sent
         CA_EVENT_NON_DELAYED_ACK, //!< Non-delayed ack is sent
-    } TcpCAEvent_t;
+    };
 
     /**
      * \brief Parameter value related to ECN enable/disable functionality
@@ -112,39 +112,39 @@
      *        https://www.kernel.org/doc/Documentation/networking/ip-sysctl.txt
      *        is not implemented.
      */
-    typedef enum
+    enum UseEcn_t
     {
         Off = 0,        //!< Disable
         On = 1,         //!< Enable
         AcceptOnly = 2, //!< Enable only when the peer endpoint is ECN capable
-    } UseEcn_t;
+    };
 
     /**
      * \brief ECN code points
      */
-    typedef enum
+    enum EcnCodePoint_t
     {
         NotECT = 0,  //!< Unmarkable
         Ect1 = 1,    //!< Markable
         Ect0 = 2,    //!< Markable
         CongExp = 3, //!< Marked
-    } EcnCodePoint_t;
+    };
 
     /**
      * \brief ECN Modes
      */
-    typedef enum
+    enum EcnMode_t
     {
         ClassicEcn, //!< ECN functionality as described in RFC 3168.
         DctcpEcn,   //!< ECN functionality as described in RFC 8257. Note: this mode is specific to
                     //!< DCTCP.
-    } EcnMode_t;
+    };
 
     /**
      * \brief Definition of the Ecn state machine
      *
      */
-    typedef enum
+    enum EcnState_t
     {
         ECN_DISABLED = 0, //!< ECN disabled traffic
         ECN_IDLE, //!< ECN is enabled  but currently there is no action pertaining to ECE or CWR to
@@ -154,7 +154,7 @@
         ECN_ECE_RCVD,    //!< Last ACK received had ECE bit set in TCP header
         ECN_CWR_SENT //!< Sender has reduced the congestion window, and sent a packet with CWR bit
                      //!< set in TCP header. This state is used for tracing.
-    } EcnState_t;
+    };
 
     /**
      * \brief Literal names of TCP states for use in log messages
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/tcp-tx-buffer.cc ns-3.38/src/internet/model/tcp-tx-buffer.cc
--- ns-3.37/src/internet/model/tcp-tx-buffer.cc	2022-11-01 17:37:24.507395000 -0700
+++ ns-3.38/src/internet/model/tcp-tx-buffer.cc	2023-03-16 20:54:23.624868600 -0700
@@ -169,13 +169,13 @@
     NS_LOG_FUNCTION(this << seq);
     m_firstByteSeq = seq;
 
-    if (m_sentList.size() > 0)
+    if (!m_sentList.empty())
     {
         m_sentList.front()->m_startSeq = seq;
     }
 
     // if you change the head with data already sent, something bad will happen
-    NS_ASSERT(m_sentList.size() == 0);
+    NS_ASSERT(m_sentList.empty());
     m_highestSack = std::make_pair(m_sentList.end(), SequenceNumber32(0));
 }
 
@@ -309,7 +309,7 @@
     NS_LOG_FUNCTION(this << numBytes << seq);
     NS_ASSERT(seq >= m_firstByteSeq);
     NS_ASSERT(numBytes <= m_sentSize);
-    NS_ASSERT(m_sentList.size() >= 1);
+    NS_ASSERT(!m_sentList.empty());
 
     auto it = m_sentList.begin();
     bool listEdited = false;
@@ -1242,7 +1242,7 @@
     TcpTxItem* item;
 
     // Keep the head items; they will then marked as lost
-    while (m_sentList.size() > 0)
+    while (!m_sentList.empty())
     {
         item = m_sentList.back();
         item->m_retrans = item->m_sacked = item->m_lost = false;
@@ -1357,7 +1357,7 @@
 void
 TcpTxBuffer::MarkHeadAsLost()
 {
-    if (m_sentList.size() > 0)
+    if (!m_sentList.empty())
     {
         // If the head is sacked (reneging by the receiver the previously sent
         // information) we revert the sacked flag.
@@ -1394,7 +1394,7 @@
     }
     else
     {
-        NS_ASSERT(m_sentList.size() > 0);
+        NS_ASSERT(!m_sentList.empty());
     }
 
     m_renoSack = true;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/tcp-westwood-plus.cc ns-3.38/src/internet/model/tcp-westwood-plus.cc
--- ns-3.37/src/internet/model/tcp-westwood-plus.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/src/internet/model/tcp-westwood-plus.cc	2023-03-16 20:54:23.624868600 -0700
@@ -0,0 +1,164 @@
+/*
+ * Copyright (c) 2013 ResiliNets, ITTC, University of Kansas
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Siddharth Gangadhar <siddharth@ittc.ku.edu>,
+ *          Truc Anh N. Nguyen <annguyen@ittc.ku.edu>,
+ *          Greeshma Umapathi
+ *
+ * James P.G. Sterbenz <jpgs@ittc.ku.edu>, director
+ * ResiliNets Research Group  https://resilinets.org/
+ * Information and Telecommunication Technology Center (ITTC)
+ * and Department of Electrical Engineering and Computer Science
+ * The University of Kansas Lawrence, KS USA.
+ *
+ * Work supported in part by NSF FIND (Future Internet Design) Program
+ * under grant CNS-0626918 (Postmodern Internet Architecture),
+ * NSF grant CNS-1050226 (Multilayer Network Resilience Analysis and Experimentation on GENI),
+ * US Department of Defense (DoD), and ITTC at The University of Kansas.
+ */
+
+#include "tcp-westwood-plus.h"
+
+#include "rtt-estimator.h"
+#include "tcp-socket-base.h"
+
+#include "ns3/log.h"
+#include "ns3/simulator.h"
+
+NS_LOG_COMPONENT_DEFINE("TcpWestwoodPlus");
+
+namespace ns3
+{
+
+NS_OBJECT_ENSURE_REGISTERED(TcpWestwoodPlus);
+
+TypeId
+TcpWestwoodPlus::GetTypeId()
+{
+    static TypeId tid =
+        TypeId("ns3::TcpWestwoodPlus")
+            .SetParent<TcpNewReno>()
+            .SetGroupName("Internet")
+            .AddConstructor<TcpWestwoodPlus>()
+            .AddAttribute(
+                "FilterType",
+                "Use this to choose no filter or Tustin's approximation filter",
+                EnumValue(TcpWestwoodPlus::TUSTIN),
+                MakeEnumAccessor(&TcpWestwoodPlus::m_fType),
+                MakeEnumChecker(TcpWestwoodPlus::NONE, "None", TcpWestwoodPlus::TUSTIN, "Tustin"))
+            .AddTraceSource("EstimatedBW",
+                            "The estimated bandwidth",
+                            MakeTraceSourceAccessor(&TcpWestwoodPlus::m_currentBW),
+                            "ns3::TracedValueCallback::DataRate");
+    return tid;
+}
+
+TcpWestwoodPlus::TcpWestwoodPlus()
+    : TcpNewReno(),
+      m_currentBW(0),
+      m_lastSampleBW(0),
+      m_lastBW(0),
+      m_ackedSegments(0),
+      m_IsCount(false),
+      m_lastAck(0)
+{
+    NS_LOG_FUNCTION(this);
+}
+
+TcpWestwoodPlus::TcpWestwoodPlus(const TcpWestwoodPlus& sock)
+    : TcpNewReno(sock),
+      m_currentBW(sock.m_currentBW),
+      m_lastSampleBW(sock.m_lastSampleBW),
+      m_lastBW(sock.m_lastBW),
+      m_fType(sock.m_fType),
+      m_IsCount(sock.m_IsCount)
+{
+    NS_LOG_FUNCTION(this);
+    NS_LOG_LOGIC("Invoked the copy constructor");
+}
+
+TcpWestwoodPlus::~TcpWestwoodPlus()
+{
+}
+
+void
+TcpWestwoodPlus::PktsAcked(Ptr<TcpSocketState> tcb, uint32_t packetsAcked, const Time& rtt)
+{
+    NS_LOG_FUNCTION(this << tcb << packetsAcked << rtt);
+
+    if (rtt.IsZero())
+    {
+        NS_LOG_WARN("RTT measured is zero!");
+        return;
+    }
+
+    m_ackedSegments += packetsAcked;
+
+    if (!(rtt.IsZero() || m_IsCount))
+    {
+        m_IsCount = true;
+        m_bwEstimateEvent.Cancel();
+        m_bwEstimateEvent = Simulator::Schedule(rtt, &TcpWestwoodPlus::EstimateBW, this, rtt, tcb);
+    }
+}
+
+void
+TcpWestwoodPlus::EstimateBW(const Time& rtt, Ptr<TcpSocketState> tcb)
+{
+    NS_LOG_FUNCTION(this);
+
+    NS_ASSERT(!rtt.IsZero());
+
+    m_currentBW = DataRate(m_ackedSegments * tcb->m_segmentSize * 8.0 / rtt.GetSeconds());
+    m_IsCount = false;
+
+    m_ackedSegments = 0;
+
+    NS_LOG_LOGIC("Estimated BW: " << m_currentBW);
+
+    // Filter the BW sample
+
+    constexpr double ALPHA = 0.9;
+
+    if (m_fType == TcpWestwoodPlus::TUSTIN)
+    {
+        DataRate sample_bwe = m_currentBW;
+        m_currentBW = (m_lastBW * ALPHA) + (((sample_bwe + m_lastSampleBW) * 0.5) * (1 - ALPHA));
+        m_lastSampleBW = sample_bwe;
+        m_lastBW = m_currentBW;
+    }
+
+    NS_LOG_LOGIC("Estimated BW after filtering: " << m_currentBW);
+}
+
+uint32_t
+TcpWestwoodPlus::GetSsThresh(Ptr<const TcpSocketState> tcb, uint32_t bytesInFlight [[maybe_unused]])
+{
+    uint32_t ssThresh = static_cast<uint32_t>((m_currentBW * tcb->m_minRtt) / 8.0);
+
+    NS_LOG_LOGIC("CurrentBW: " << m_currentBW << " minRtt: " << tcb->m_minRtt
+                               << " ssThresh: " << ssThresh);
+
+    return std::max(2 * tcb->m_segmentSize, ssThresh);
+}
+
+Ptr<TcpCongestionOps>
+TcpWestwoodPlus::Fork()
+{
+    return CreateObject<TcpWestwoodPlus>(*this);
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/tcp-westwood-plus.h ns-3.38/src/internet/model/tcp-westwood-plus.h
--- ns-3.37/src/internet/model/tcp-westwood-plus.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/src/internet/model/tcp-westwood-plus.h	2023-03-16 20:54:23.624868600 -0700
@@ -0,0 +1,129 @@
+/*
+ * Copyright (c) 2013 ResiliNets, ITTC, University of Kansas
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Siddharth Gangadhar <siddharth@ittc.ku.edu>, Truc Anh N. Nguyen <annguyen@ittc.ku.edu>,
+ * and Greeshma Umapathi
+ *
+ * James P.G. Sterbenz <jpgs@ittc.ku.edu>, director
+ * ResiliNets Research Group  https://resilinets.org/
+ * Information and Telecommunication Technology Center (ITTC)
+ * and Department of Electrical Engineering and Computer Science
+ * The University of Kansas Lawrence, KS USA.
+ *
+ * Work supported in part by NSF FIND (Future Internet Design) Program
+ * under grant CNS-0626918 (Postmodern Internet Architecture),
+ * NSF grant CNS-1050226 (Multilayer Network Resilience Analysis and Experimentation on GENI),
+ * US Department of Defense (DoD), and ITTC at The University of Kansas.
+ */
+
+#ifndef TCP_WESTWOOD_H
+#define TCP_WESTWOOD_H
+
+#include "tcp-congestion-ops.h"
+
+#include "ns3/data-rate.h"
+#include "ns3/event-id.h"
+#include "ns3/tcp-recovery-ops.h"
+#include "ns3/traced-value.h"
+
+namespace ns3
+{
+
+class Time;
+
+/**
+ * \ingroup congestionOps
+ *
+ * \brief An implementation of TCP Westwood+.
+ *
+ * Westwood+ employ the AIAD (Additive Increase/Adaptive Decrease)
+ * congestion control paradigm. When a congestion episode happens,
+ * instead of halving the cwnd, these protocols try to estimate the network's
+ * bandwidth and use the estimated value to adjust the cwnd.
+ * While Westwood performs the bandwidth sampling every ACK reception,
+ * Westwood+ samples the bandwidth every RTT.
+ *
+ * The two main methods in the implementation are the CountAck (const TCPHeader&)
+ * and the EstimateBW (int, const, Time). The CountAck method calculates
+ * the number of acknowledged segments on the receipt of an ACK.
+ * The EstimateBW estimates the bandwidth based on the value returned by CountAck
+ * and the sampling interval (last RTT).
+ *
+ * WARNING: this TCP model lacks validation and regression tests; use with caution.
+ */
+class TcpWestwoodPlus : public TcpNewReno
+{
+  public:
+    /**
+     * \brief Get the type ID.
+     * \return the object TypeId
+     */
+    static TypeId GetTypeId();
+
+    TcpWestwoodPlus();
+    /**
+     * \brief Copy constructor
+     * \param sock the object to copy
+     */
+    TcpWestwoodPlus(const TcpWestwoodPlus& sock);
+    ~TcpWestwoodPlus() override;
+
+    /**
+     * \brief Filter type (None or Tustin)
+     */
+    enum FilterType
+    {
+        NONE,
+        TUSTIN
+    };
+
+    uint32_t GetSsThresh(Ptr<const TcpSocketState> tcb, uint32_t bytesInFlight) override;
+
+    void PktsAcked(Ptr<TcpSocketState> tcb, uint32_t packetsAcked, const Time& rtt) override;
+
+    Ptr<TcpCongestionOps> Fork() override;
+
+  private:
+    /**
+     * Update the total number of acknowledged packets during the current RTT
+     *
+     * \param [in] acked the number of packets the currently received ACK acknowledges
+     */
+    void UpdateAckedSegments(int acked);
+
+    /**
+     * Estimate the network's bandwidth
+     *
+     * \param [in] rtt the RTT estimation.
+     * \param [in] tcb the socket state.
+     */
+    void EstimateBW(const Time& rtt, Ptr<TcpSocketState> tcb);
+
+  protected:
+    TracedValue<DataRate> m_currentBW; //!< Current value of the estimated BW
+    DataRate m_lastSampleBW;           //!< Last bandwidth sample
+    DataRate m_lastBW;                 //!< Last bandwidth sample after being filtered
+    FilterType m_fType;                //!< 0 for none, 1 for Tustin
+
+    uint32_t m_ackedSegments;  //!< The number of segments ACKed between RTTs
+    bool m_IsCount;            //!< Start keeping track of m_ackedSegments for Westwood+ if TRUE
+    EventId m_bwEstimateEvent; //!< The BW estimation event for Westwood+
+    Time m_lastAck;            //!< The last ACK time
+};
+
+} // namespace ns3
+
+#endif /* TCP_WESTWOOD_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/udp-header.cc ns-3.38/src/internet/model/udp-header.cc
--- ns-3.37/src/internet/model/udp-header.cc	2022-11-01 17:37:24.507395000 -0700
+++ ns-3.38/src/internet/model/udp-header.cc	2023-03-16 20:54:23.624868600 -0700
@@ -241,7 +241,7 @@
 }
 
 uint16_t
-UdpHeader::GetChecksum()
+UdpHeader::GetChecksum() const
 {
     return m_checksum;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/udp-header.h ns-3.38/src/internet/model/udp-header.h
--- ns-3.37/src/internet/model/udp-header.h	2022-11-01 17:37:24.507395000 -0700
+++ ns-3.38/src/internet/model/udp-header.h	2023-03-16 20:54:23.624868600 -0700
@@ -158,7 +158,7 @@
      * \brief Return the checksum (only known after a Deserialize)
      * \return The checksum for this UdpHeader
      */
-    uint16_t GetChecksum();
+    uint16_t GetChecksum() const;
 
   private:
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/udp-socket-impl.cc ns-3.38/src/internet/model/udp-socket-impl.cc
--- ns-3.37/src/internet/model/udp-socket-impl.cc	2022-11-01 17:37:24.507395000 -0700
+++ ns-3.38/src/internet/model/udp-socket-impl.cc	2023-03-16 20:54:23.624868600 -0700
@@ -232,6 +232,8 @@
     }
     if (done)
     {
+        m_shutdownRecv = false;
+        m_shutdownSend = false;
         return 0;
     }
     return -1;
@@ -752,7 +754,7 @@
         tag.SetHopLimit(GetIpv6HopLimit());
         p->AddPacketTag(tag);
     }
-    // There is no analgous to an IPv4 broadcast address in IPv6.
+    // There is no analogous to an IPv4 broadcast address in IPv6.
     // Instead, we use a set of link-local, site-local, and global
     // multicast addresses.  The Ipv6 routing layers should all
     // provide an interface-specific route to these addresses such
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/udp-socket-impl.h ns-3.38/src/internet/model/udp-socket-impl.h
--- ns-3.37/src/internet/model/udp-socket-impl.h	2022-11-01 17:37:24.507395000 -0700
+++ ns-3.38/src/internet/model/udp-socket-impl.h	2023-03-16 20:54:23.628868600 -0700
@@ -93,8 +93,8 @@
      */
     void SetUdp(Ptr<UdpL4Protocol> udp);
 
-    enum SocketErrno GetErrno() const override;
-    enum SocketType GetSocketType() const override;
+    SocketErrno GetErrno() const override;
+    SocketType GetSocketType() const override;
     Ptr<Node> GetNode() const override;
     int Bind() override;
     int Bind6() override;
@@ -262,11 +262,11 @@
     uint16_t m_defaultPort;                        //!< Default port
     TracedCallback<Ptr<const Packet>> m_dropTrace; //!< Trace for dropped packets
 
-    mutable enum SocketErrno m_errno; //!< Socket error code
-    bool m_shutdownSend;              //!< Send no longer allowed
-    bool m_shutdownRecv;              //!< Receive no longer allowed
-    bool m_connected;                 //!< Connection established
-    bool m_allowBroadcast;            //!< Allow send broadcast packets
+    mutable SocketErrno m_errno; //!< Socket error code
+    bool m_shutdownSend;         //!< Send no longer allowed
+    bool m_shutdownRecv;         //!< Receive no longer allowed
+    bool m_connected;            //!< Connection established
+    bool m_allowBroadcast;       //!< Allow send broadcast packets
 
     std::queue<std::pair<Ptr<Packet>, Address>> m_deliveryQueue; //!< Queue for incoming packets
     uint32_t m_rxAvailable; //!< Number of available bytes to be received
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/windowed-filter.h ns-3.38/src/internet/model/windowed-filter.h
--- ns-3.37/src/internet/model/windowed-filter.h	2022-11-01 17:37:24.507395000 -0700
+++ ns-3.38/src/internet/model/windowed-filter.h	2023-03-16 20:54:23.628868600 -0700
@@ -136,14 +136,14 @@
 {
   public:
     /**
-     * \brief contructor
+     * \brief constructor
      */
     WindowedFilter()
     {
     }
 
     /**
-     * \brief contructor
+     * \brief constructor
      * \param windowLength is the period after which a best estimate expires.
      * \param zeroValue is used as the uninitialized value for objects of T. Importantly,
      * zeroValue should be an invalid value for a true sample.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/global-route-manager-impl-test-suite.cc ns-3.38/src/internet/test/global-route-manager-impl-test-suite.cc
--- ns-3.37/src/internet/test/global-route-manager-impl-test-suite.cc	2022-11-01 17:37:24.507395000 -0700
+++ ns-3.38/src/internet/test/global-route-manager-impl-test-suite.cc	2023-03-16 20:54:23.628868600 -0700
@@ -32,12 +32,12 @@
 
 /**
  * \ingroup internet
+ * \ingroup tests
  * \defgroup internet-test internet module tests
  */
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief Global Route Manager Test
  */
@@ -224,7 +224,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief Global Route Manager TestSuite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/ipv4-address-generator-test-suite.cc ns-3.38/src/internet/test/ipv4-address-generator-test-suite.cc
--- ns-3.37/src/internet/test/ipv4-address-generator-test-suite.cc	2022-11-01 17:37:24.507395000 -0700
+++ ns-3.38/src/internet/test/ipv4-address-generator-test-suite.cc	2023-03-16 20:54:23.628868600 -0700
@@ -23,7 +23,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 network number Test
  */
@@ -84,7 +83,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 address allocator Test
  */
@@ -142,7 +140,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 network and address allocator Test
  */
@@ -214,7 +211,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 AddressGenerator example (sort of) Test
  */
@@ -273,7 +269,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 address collision Test
  */
@@ -346,7 +341,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 Address Generator TestSuite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/ipv4-address-helper-test-suite.cc ns-3.38/src/internet/test/ipv4-address-helper-test-suite.cc
--- ns-3.37/src/internet/test/ipv4-address-helper-test-suite.cc	2022-11-01 17:37:24.507395000 -0700
+++ ns-3.38/src/internet/test/ipv4-address-helper-test-suite.cc	2023-03-16 20:54:23.628868600 -0700
@@ -24,7 +24,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 network allocator helper Test
  */
@@ -78,7 +77,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 address allocator helper Test
  */
@@ -132,7 +130,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 reset allocator helper Test
  */
@@ -201,7 +198,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 address helper Test
  */
@@ -281,7 +277,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 Address Helper TestSuite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/ipv4-deduplication-test.cc ns-3.38/src/internet/test/ipv4-deduplication-test.cc
--- ns-3.37/src/internet/test/ipv4-deduplication-test.cc	2022-11-01 17:37:24.507395000 -0700
+++ ns-3.38/src/internet/test/ipv4-deduplication-test.cc	2023-03-16 20:54:23.628868600 -0700
@@ -57,7 +57,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 Deduplication Test
  *
@@ -447,28 +446,34 @@
 Ipv4DeduplicationTest::CheckPackets(const std::string& name)
 {
     // a priori determined packet receptions based on initial TTL of 4, disabled de-dup
-    std::map<std::string, uint32_t> packets = {{"A", 14},
-                                               {"B", 16},
-                                               {"C", 16},
-                                               {"D", 16},
-                                               {"E", 4}};
+    std::map<std::string, uint32_t> packets = {
+        {"A", 14},
+        {"B", 16},
+        {"C", 16},
+        {"D", 16},
+        {"E", 4},
+    };
 
     // a priori determined packet receptions based on
-    std::map<std::string, uint32_t> packetsDuped = {{"A", 0},
-                                                    {"B", 1},
-                                                    {"C", 1},
-                                                    {"D", 1},
-                                                    {"E", 1}};
+    std::map<std::string, uint32_t> packetsDuped = {
+        {"A", 0},
+        {"B", 1},
+        {"C", 1},
+        {"D", 1},
+        {"E", 1},
+    };
     // a priori determined packet receptions based on initial TTL of 4, degenerate de-dup
     // There are TTL (4) rounds of packets.  Each round a node will register a
     // received packet if another connected node transmits.  A misses the 1st round
     // since it is the only one transmitting.  D is not connected to A in 1st round
     // either.  E only hears a packet in the 3rd and 4th rounds.
-    std::map<std::string, uint32_t> degenerates = {{"A", 3},
-                                                   {"B", 4},
-                                                   {"C", 4},
-                                                   {"D", 3},
-                                                   {"E", 2}};
+    std::map<std::string, uint32_t> degenerates = {
+        {"A", 3},
+        {"B", 4},
+        {"C", 4},
+        {"D", 3},
+        {"E", 2},
+    };
 
     switch (m_mode)
     {
@@ -540,7 +545,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 Deduplication TestSuite
  */
@@ -566,7 +570,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 Deduplication Performance Test
  *
@@ -724,7 +727,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 Deduplication Performance TestSuite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/ipv4-forwarding-test.cc ns-3.38/src/internet/test/ipv4-forwarding-test.cc
--- ns-3.37/src/internet/test/ipv4-forwarding-test.cc	2022-11-01 17:37:24.507395000 -0700
+++ ns-3.38/src/internet/test/ipv4-forwarding-test.cc	2023-03-16 20:54:23.628868600 -0700
@@ -44,7 +44,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 Forwarding Test
  */
@@ -227,7 +226,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 Forwarding TestSuite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/ipv4-fragmentation-test.cc ns-3.38/src/internet/test/ipv4-fragmentation-test.cc
--- ns-3.37/src/internet/test/ipv4-fragmentation-test.cc	2022-11-01 17:37:24.507395000 -0700
+++ ns-3.38/src/internet/test/ipv4-fragmentation-test.cc	2023-03-16 20:54:23.628868600 -0700
@@ -59,7 +59,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief Tag used in IPv4 Fragmentation Test
  */
@@ -117,7 +116,7 @@
      * \brief Get the token.
      * \returns The token.
      */
-    uint64_t GetToken()
+    uint64_t GetToken() const
     {
         return token;
     }
@@ -125,7 +124,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 Fragmentation Test
  */
@@ -579,7 +577,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 Fragmentation TestSuite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/ipv4-global-routing-test-suite.cc ns-3.38/src/internet/test/ipv4-global-routing-test-suite.cc
--- ns-3.37/src/internet/test/ipv4-global-routing-test-suite.cc	2022-11-01 17:37:24.507395000 -0700
+++ ns-3.38/src/internet/test/ipv4-global-routing-test-suite.cc	2023-03-16 20:54:23.628868600 -0700
@@ -118,7 +118,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 GlobalRouting Link test
  */
@@ -203,7 +202,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 GlobalRouting LAN test
  */
@@ -285,7 +283,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 GlobalRouting Two Link test
  */
@@ -405,7 +402,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 GlobalRouting Two LAN test
  */
@@ -506,7 +502,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 GlobalRouting Bridge test
  */
@@ -690,7 +685,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 GlobalRouting Two bridges test
  */
@@ -848,7 +842,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 Dynamic GlobalRouting test
  */
@@ -1159,7 +1152,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 Dynamic GlobalRouting /32 test
  */
@@ -1323,7 +1315,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 GlobalRouting TestSuite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/ipv4-header-test.cc ns-3.38/src/internet/test/ipv4-header-test.cc
--- ns-3.37/src/internet/test/ipv4-header-test.cc	2022-11-01 17:37:24.507395000 -0700
+++ ns-3.38/src/internet/test/ipv4-header-test.cc	2023-03-16 20:54:23.628868600 -0700
@@ -53,7 +53,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 Header Test
  */
@@ -63,7 +62,7 @@
     Ipv4Header m_receivedHeader;  //!< Received header.
 
     /**
-     * \brief Send a packet with speciic DSCP and ECN fields.
+     * \brief Send a packet with specific DSCP and ECN fields.
      * \param socket The source socket.
      * \param to The destination address.
      * \param dscp The DSCP field.
@@ -75,7 +74,7 @@
                                Ipv4Header::EcnType ecn);
 
     /**
-     * \brief Send a packet with speciic DSCP and ECN fields.
+     * \brief Send a packet with specific DSCP and ECN fields.
      * \param socket The source socket.
      * \param to The destination address.
      * \param dscp The DSCP field.
@@ -293,7 +292,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 Header TestSuite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/test/ipv4-list-routing-test-suite.cc ns-3.38/src/internet/test/ipv4-list-routing-test-suite.cc
--- ns-3.37/src/internet/test/ipv4-list-routing-test-suite.cc	2022-11-01 17:37:24.507395000 -0700
+++ ns-3.38/src/internet/test/ipv4-list-routing-test-suite.cc	2023-03-16 20:54:23.628868600 -0700
@@ -24,7 +24,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 dummy routing class (A)
  */
@@ -77,7 +76,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 dummy routing class (B)
  */
@@ -130,7 +128,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 ListRouting negative test.
  */
@@ -165,7 +162,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 ListRouting positive test.
  */
@@ -205,7 +201,6 @@
 
 /**
  * \ingroup internet-test
- * \ingroup tests
  *
  * \brief IPv4 ListRouting TestSuite
  */
